      SUBROUTINE DE02D(FU,M,JSTART,A,HMIN,EPS,P,YX,X,H,BUL,XP,YP,E1,    DE020010
     1                 E2,E3,E4,R,R0,R1,R2,R3,YD,IERR)                  DE020020
         INTEGER IERR,JSTART,M                                          DE020030
         DOUBLE PRECISION A,E1,E2,E3,E4,EPS,H,HMIN,P,R,R0,R1,R2,R3,
     1                    X,XP,YD,YP,YX                                 DE020040
         LOGICAL BUL                                                    DE020050
         DIMENSION A(M,M),E1(M,M),E2(M,M),E3(M,M),E4(M,M),R(M),R0(M),   DE020060
     1             R1(M),R2(M),R3(M),YD(M),YP(M),YX(M)                  DE020070
         DOUBLE PRECISION DABS,DSIGN                                    DE020080
         EXTERNAL AME2D,DE02DS,DE04DQ,UTDE21                            DE020090
         INTEGER I,J                                                    DE020100
         DOUBLE PRECISION C1,EPS1                                       DE020110
         LOGICAL BULD,BULEX,BULHM                                       DE020120
       IERR = 0                                                         DE020130
       EPS1 = EPS/32.D0                                                 DE020140
       BULD = .TRUE.                                                    DE020150
       BULHM = .FALSE.                                                  DE020160
       BULEX = .FALSE.                                                  DE020170
       IF (JSTART) 40, 60, 10                                           DE020180
   10  CONTINUE                                                         DE020190
       IF (JSTART .EQ. 1) GO TO 80                                      DE020200
          DO 30 I = 1, M                                                DE020210
             DO 20 J = 1, M                                             DE020220
                E1(J,I) = E2(J,I)                                       DE020230
   20        CONTINUE                                                   DE020240
   30     CONTINUE                                                      DE020250
          GO TO 70                                                      DE020260
   40  CONTINUE                                                         DE020270
       DO 50 I = 1, M                                                   DE020280
          YX(I) = YP(I)                                                 DE020290
   50  CONTINUE                                                         DE020300
       X = XP                                                           DE020310
   60  CONTINUE                                                         DE020320
       C1 = H/4.D0                                                      DE020330
       CALL AME2D(A,C1,M,E1,R,E3,E4)                                    DE020340
       IF (BULEX) GO TO 80                                              DE020350
   70  CONTINUE                                                         DE020360
       CALL DE04DQ(M,E1,E2)                                             DE020370
   80  CONTINUE                                                         DE020380
       C1 = H/2.D0                                                      DE020390
       CALL DE02DS(FU,M,X,YX,H,E2,YD,R1,R2,R3)                          DE020400
       CALL DE02DS(FU,M,X,YX,C1,E1,R0,R1,R2,R3)                         DE020410
       CALL DE02DS(FU,M,X + C1,R0,C1,E1,R,R1,R2,R3)                     DE020420
       DO 90 I = 1, M                                                   DE020430
          R1(I) = (R(I) - YD(I))/15.D0                                  DE020440
          C1 = DABS(R1(I))                                              DE020450
          IF (DABS(R(I)) .GE. P) C1 = C1/DABS(R(I))                     DE020460
          IF (C1 .GT. EPS1) BULD = .FALSE.                              DE020470
          IF (C1 .GE. EPS) GO TO 120                                    DE020480
   90     CONTINUE                                                      DE020490
          DO 100 I = 1, M                                               DE020500
             YP(I) = YX(I)                                              DE020510
  100     CONTINUE                                                      DE020520
          XP = X                                                        DE020530
          DO 110 I = 1, M                                               DE020540
             YX(I) = R(I)                                               DE020550
  110     CONTINUE                                                      DE020560
          X = X + H                                                     DE020570
          IF (BULD) H = H*2.D0                                          DE020580
          GO TO 160                                                     DE020590
  120  CONTINUE                                                         DE020600
       IF (BULHM) GO TO 150                                             DE020610
          H = H/2.D0                                                    DE020620
          BUL = .FALSE.                                                 DE020630
          BULEX = .TRUE.                                                DE020640
          DO 140 I = 1, M                                               DE020650
             DO 130 J = 1, M                                            DE020660
                E2(J,I) = E1(J,I)                                       DE020670
  130        CONTINUE                                                   DE020680
  140     CONTINUE                                                      DE020690
          IF (DABS(H) .GT. DABS(HMIN)) GO TO 60                         DE020700
             H = DSIGN(HMIN,H)                                          DE020710
             BULHM = .TRUE.                                             DE020720
             BULEX = .FALSE.                                            DE020730
             GO TO 60                                                   DE020740
  150  CONTINUE                                                         DE020750
       IERR = 65                                                        DE020760
       CALL UTDE21(IERR,2)                                              DE020770
  160  CONTINUE                                                         DE020780
       JSTART = 1                                                       DE020790
       IF (BULD) JSTART = 2                                             DE020800
       RETURN                                                           DE020810
      END                                                               DE020820
